
	;LIST      P=16F84
	LIST      P=16F628

	;include "P16F84a.inc"		; 4.000 MHz
	include "P16F628.inc"		; 4.000 MHz
	__CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON& _XT_OSC

MSB		EQU		07
LSB		EQU		00

	#define	_DX	Modes,0		; Divider 0- 1, 1- 64
	#define	_LX	Modes,1 	; 0- Lx mode
	#define	_FX	Modes,2		; 0- FCounter, 1- LC measure
	#define	_CX	Modes,3		; 0- Cx mode
	#define	_CAL	PORTA,0		; 0- disable, 1- enable relay
	#define	_BAT	PORTA,1		; 0- low bat
	#define	_L1_SHORT	PORTB,6		; 0- disable, 1- enable relay
	#define	_RS	PORTA,2
	#define	_E	PORTA,3

	CBLOCK 0x020

	Modes
	Flags
	Count1
	Count2
	Temp
	TSign
	Temp1
	Temp2
	Temp3
	Temp4
	Sign
	CP
	LP

	T0
	T1

	T2
	T3
	T4
	T5

	LX
	L0
	L1
	L2
	
	CX
	C0
	C1
	C2

	FX
	F0
	F1
	F2

	AX		; MSB
	A0
	A1
	A2		; LSB

	A3
	A4
	A5

	BX
	B0
	B1
	B2

	CSX
	CS0
	CS1
	CS2

	BCD0
	BCD1
	BCD2
	BCD3
	BCD4

	TimerHH
	TimerH
	TimerM
	TimerL

	FDX
	FD0
	FD1
	FD2

	ENDC

		ORG		0x2100	;; Area EEPROM 

	;; The data; the Address 	
	DE	0x03, 0xE8		; ; 0x00 =X1 = 1000 by default 
	DE	0x03, 0xE8		;  0x02 =X2 = 1.000 by default 
	DE	'M','H','z',0x00	; 0x04 
	DE	'K','O','N','S','T','A','N','T','A', ' ','X',0x00	; 0x08
	DE	'K','A','L','I','B','R','A','C','I','J','A',0x00; 0x14
	DE	'K','A','P','A','C','I',0x00		; 0x20
	DE	'I','N','D','U','K','T','I','V','I','T','E','T',0x00; 0x27
	DE	'F','R','E','K','V','E','N','C','I','J','A',0x00	; 0x34
		ORG		0x0000
		bcf		STATUS,RP1
		clrf		PORTA
		movlw 		0x0007
		movwf 		CMCON
		clrf		Flags
		clrf		PORTB
		
		bsf			STATUS, RP0
		movlw		b'11110000'
		movwf		TRISB
		movlw		b'00000010'
		movwf		TRISA
		movlw		b'00110111'	;Preddelitel' 1:256, the connection of resistors
		movwf		OPTION_REG
		bcf			STATUS, RP0
		clrf		INTCON

		bsf			PORTA, 4

;	;Initialization LCD in the 4th the bit regime		
InitLCD		call		Delay05sec
			movlw		3
			movwf		Temp
			movwf		PORTB
			
SetLoop		bsf			_E		; 3 times
			call		Dly5
			bcf			_E
			decfsz		Temp
			goto		SetLoop
			movlw		2
			movwf		PORTB
			call		Send
			movlw		28		;; the 4th bit, 2 lines, 
			call		CmdLCD
    		movlw		0C		; To include the display
    		call		CmdLCD
    		movlw		6
    		call		CmdLCD
			call		ClrDSP
			movlw		0x85 ;C5		; the Cursor for first line
			call		CmdLCD
			movlw		'I'			;	
			call		CharLCD		; 
			movlw		'V'
			call		CharLCD
           		 movlw		'A'			; 
			call		CharLCD		;
			movlw		'N'
			call		CharLCD
            		movlw		' '			; 
			call		CharLCD		; 
			movlw		'D'
			call		CharLCD
			
			clrf		Temp
			movlw		0x13
			call		DelayXsec
			call		ClrRegs

SetConst	call		ClrDSP		; ; To clear the display 

			btfsc		PORTB, 7	;constant switch
			goto		Main
			bsf STATUS,RP0
			movlw		0x08
			call		ReadWString

			call		GetSwitch

			movlw		1
			btfss		_DX		
			movlw		2
			call		NumLCD
	
			clrw
			btfss		_DX		
			movlw		0x02
			movwf		Temp
			call		EEPROM_To_B
			call		ShowX

ConstLoop	call		GetSwitch

			btfss		Modes, 4
			call		IncB
			btfss		Modes, 5
			call		DecB

			btfss		Flags, 1
			goto		ConstLoop
			bsf 		STATUS,RP0
			movf		B1, W
			movwf		EEDATA
			bcf 		STATUS,RP0
			movf		Temp, W
			call		Save_2_EE
			bsf 		STATUS,RP0		
			incf		EEADR, F
			movf		B2, W
			movwf		EEDATA
			bcf 		STATUS,RP0
			call		Save_2_EE+1	;; we Pass record of the address from W 
			goto		SetConst


Main		call		ClrDSP		; To clear the display 
			call		GetSwitch	;  Scanning of switches 
			call		CursorHome
			btfss		_FX
			goto		FCounter	; Transition in a mode chastotometra 
			call		ClrDSP
			goto		Calibration
;	Scanning switches 
GetSwitch	bsf			STATUS, RP0
			movlw		0xFF		; All ports In on an input 
			movwf		TRISB
			bcf			STATUS, RP0	
			call		Dly5
			movf		PORTB, W	;  Reading of ports 
			movwf		Modes		; in the register-accumulator 
			bsf			STATUS, RP0
			movlw		b'11110000'
			movwf		TRISB
			bcf			STATUS, RP0	

			bcf			Flags, 1
			movf		Modes, W	; Installation of a flag if position
			xorwf		Flags, W	; the switch _DX (F1/F2)
			andlw		1		; it has been changed.
			btfss		STATUS, Z	; Includes double calibration
			bsf			Flags, 1

			bcf			Flags, 0	; Preservation of the last
			btfsc		Modes, 0	; positions of the switch
			bsf			Flags, 0
			return

;	Definition and indication of the category of the battery
TestBat		movlw		0xC0		; the Cursor for the second line
			call		CmdLCD
			movlw		' '		; the Blank, if norm
			btfss		PORTA,1
			movlw		0x21		; '!',if it is lowered
			goto		CharLCD		; Indication and an output

;	An input in a mode chastotometra
FCounter	bcf			Flags, 6	; Dump of a flag of double calibration
			call		ClrDSP		; Clearing of all display
			bsf STATUS,RP0
			movlw		0x34		; the Conclusion of the name of a mode
			call		ReadWString	; "Frequancy"

;	A basis cycle chastotometra
FLoop		call		Measure		;  Measurement of frequency
			call		SecLine
			call		BCD
			btfss		_DX
			goto		$+3
			movf		BCD4, W		; Hundreds in MHz
			call		NumLCD

			movlw		BCD3		; Tens in MHz
			call		DispBCD

			movlw		BCD3		; Units of MHz
			call		DispBCD

			movlw		','
			call		CharLCD

			movlw		BCD2		; Hundreds kGts
			call		DispBCD

			movlw		BCD2		; Tens kGts
			call		DispBCD

			call		Digit1		; Units kGts

			call		DispDot
			call		Digit2		; Hundreds in Hz
			call		Digit3		; Tens in Hz
			btfss		_DX
			call		Digit4		; Units of Hz
			bsf STATUS,RP0
			movlw		0x04
			call		ReadWString

			call		TestBat		; in 16-th znakomeste

			call		GetSwitch
			btfss		_FX		; If the mode is not changed to continue
			goto		FLoop
			call		ClrDSP		; otherwise clearing  and an output
			btfss		Flags, 7	; a mode of expectation of calibration
			goto		Main		; or a basis cycle, if
			goto		Meter		; calibration already was

IncB		incf		B2, F
			btfsc		STATUS, Z
			incf		B1, F
			goto		ShowX


;	  
DecB		movf		B2, F
			btfsc		STATUS, Z
			decf		B1, F
			decf		B2, F

ShowX		movlw		BX
			call		Copy_To_A
			call		BCD
			movlw		0x8B
			call		SecLine
			call		Digit1
			btfss		_DX		
			call		DispDot
			call		Digit2
			call		Digit3
			call		Digit4
			call		DispSP
			call		Delay05sec
			return


; Copying "to destination" the block (4 bajta) given
; Temp1 - the address of the addressee
; Temp2 = the address of a source
CEQUA		movlw		CX		; C=A
Copy_From_A	movwf		Temp1		; Xw=A
			movlw		AX
			movwf		Temp2
			goto		Copy

BEQUA		movlw		AX		; B=A
Copy_To_B	movwf		Temp2		; B=Xw
			movlw		BX
			goto		Copy_B

AEQUF		movlw		FX		; A=F
Copy_To_A	movwf		Temp2		; A=Xw
			movlw		AX

Copy_B		movwf		Temp1
Copy		movlw		4		; Volume of the block
			movwf		Count1
Copy_Loop	movf		Temp2, W
			movwf		FSR
			movf		INDF, W
			movwf		Temp3
			movf		Temp1, W
			movwf		FSR
			movf		Temp3, W
			movwf		INDF
			incf		Temp1, F
			incf		Temp2, F
			decfsz		Count1, F
			goto		Copy_Loop
			return

;	Data reading from EEPROM in polublok B
EEPROM_To_B	bsf			STATUS, RP0
			movwf		EEADR		; Address first bajta
			bcf 		STATUS,RP0
			call		ClrB
	        call		ReadEEPROM
			movwf		B1
			bsf 		STATUS,RP0
			incf		EEADR, F
			bcf 		STATUS,RP0
	        call		ReadEEPROM
			movwf		B2
			return

;Reading a line from EEPROM will not meet yet 0x00  and a conclusion to the display
ReadWString	movwf		EEADR
ReadFString	movf		EEADR, W
		bcf 		STATUS,RP0
			call		ReadEEPROM
			andlw		0xFF
			btfsc		STATUS, Z
			bcf		STATUS,RP0
			return
			call		CharLCD
			bsf 		STATUS,RP0
			incf		EEADR, F
			goto		ReadFString
			

;	Reading EEPROM
ReadEEPROM	bsf			STATUS, RP0
	        bsf			EECON1, RD	; Inquiry about reading EEPROM
			movf		EEDATA, W
		bcf 		STATUS,RP0
			return

;	Preservation of the data in EEPROM
Save_2_EE		bsf 		STATUS,RP0
			movwf		EEADR
			bsf			EECON1, WREN
			movlw		0x55
			movwf		EECON2
			movlw		0xAA
			movwf		EECON2
			bsf			EECON1, WR
			bcf			EECON1, WREN
			btfsc		EECON1, WR
			bcf			STATUS, RP0
			goto		$-1
			
			return

;	Clearing registers of the RAM with 0x0F on 0x50
ClrRegs		movlw		0x0F
			movwf		FSR
			movlw		.65
			goto		ClrLoop-1

ClrB		movlw		BX		; Clearing of the block In
			goto		ClrA+1

ClrA		movlw		AX		; Clearing of the block And
			movwf		FSR
			movlw		4
			movwf		Count1

ClrLoop		clrf		INDF		; the Cycle of clearing
			incf		FSR, F
			decfsz		Count1, F
			goto		ClrLoop
			return

;An input in a mode of double calibration (for big induktivnostej)
DoubleCheck	btfsc		Flags, 5	; the Output, if inductance
			goto		Meter		; have disconnected from plugs

			bsf			Flags, 6	; Installation of a flag of double calibration

			call		Measure
			goto		Double

DoubleLX	movlw		CSX		; Sohranienie in CS total capacity
			call		Copy_From_A	; coils, N1 and installation
	
			call		AEQUF

CalcDouble	movlw		CSX
			call		Copy_To_B	; B=Cs
			call		LCalc		; Calculation of inductance [L1+Lx]

			movlw		LX
			call		Copy_To_B
			call		Sub		; Lx=[L1+Lx]-L1
			call		DispLX		; the Conclusion to the display

			movlw		CX		; Extraction of capacity N1 and installation
			call		Copy_To_B	; in block B,,
			movlw		CSX		; and total C1+eaoooee+iiioa?
			call		Copy_To_A	; in block A..
			call		Sub		; YOmkosk coils = A-V

			movlw		0xC9		;the Cursor on 3 znakomesto
			call		CmdLCD
			bsf			_LX		; To include indication of capacity
			goto		DispVal+1	; and to deduce her

			goto		Meter

;	Simply calculation under formula F^2=1/4*Pi*L*C
LCalc		call		Mpy		; A=F^2*C
			call		BEQUA		; B=F^2*C

			movlw		0xB2		; A=1013211836423377,7
			movwf		AX		; (H'B2.66 60 B1)
			movlw		0x66
			movwf		A0
			movlw		0x60
			movwf		A1
			movlw		0xB1
			movwf		A2

			call		Div		; A=1.013212E15/(F1^2*Cs)=L
			movlw		0x02
			call		X_To_B		

			call		ClrB		; B=1000pf (H'8A.7A 00 00)
			movlw		0x8A
			movwf		BX
			movlw		0x7A
			movwf		B0
	
			call		Div
			return


X_To_B 		call		EEPROM_To_B	; Loading of factor X
			call		ASwapB
			call		Float
			call		Mpy
			return

ASwapB		movlw		T2
			call		Copy_From_A
			movlw		BX
			call		Copy_To_A
			movlw		T2
			call		Copy_To_B
			return

; Self-calibration - definition C1 and L1 and sohranienie their values
; C1=F2^2 * C2/(F1^2-F2^2)
; L1=1/(4*pi^2*[F1/5]^2*C1) = 1.013212E15/F1^2/C1

Calibration	call		ClrDSP
			bsf	STATUS,RP0
			movlw		0x14
			call		ReadWString

			call		Measure		; Preparation of a predivider for work
			clrf		Temp
			movlw		0x13
			call		DelayXsec
			call		ClrRegs
			call		Measure
			movlw		FDX
			call		Copy_From_A	; F=F1^2

Double		movlw		FX
			call		Copy_From_A	; F=F1^2
			bsf			_CAL		; Connection N2 to a contour
			call		Delay05sec
			call		TestBat
			movlw		0x09
			call		DelayXsec	; the Establishment of stable generation
			call		Measure
			movlw		CSX
			call		Copy_From_A	; CS=F2^2 temporarily
			call		BEQUA		; B=F2^2
			bcf			_CAL		; Switching-off N2
			call		AEQUF		; A=F1^2
			call		Sub		; A=F1^2 - F2^2
			call		BEQUA		; B=F1^2 - F2^2
			movlw		CSX		; A=F2^2
			call		Copy_To_A
			call		Div		; A=F2^2/(F1^2 - F2^2)
			clrw				; the Address in EEPROM 0x2100
			call		X_To_B		; Loading of factor X1 (C2)
						; A=F2^2*1000pf/(F1^2-F2^2)=C
			btfsc		Flags, 6	; Transition  at double calibration
			goto		DoubleLX
			call		CEQUA		; C=A
			call		BEQUA		; B=C
			call		AEQUF		; A=F1^2
			call		LCalc
			movlw		LX		; L=A
			call		Copy_From_A
			call		ClrDSP
			movlw		'O'		; 'OK'
			call		CharLCD		; Calibration is completed
			movlw		'K'
			call		CharLCD
			call		TestBat
			movlw		0x5 ;13
			call		DelayXsec
;			call		ClrRegs
			bsf			Flags, 7	; the Flag of passage of calibration

;***************************************************************************************************   
;	A basis cycle of measurement
;***************************************************************************************************
Meter		call		GetSwitch
			btfss		_FX
			goto		FCounter	; the Mode chastotometra
			btfsc		_LX			; MEASURING INDUCTANCE? GOTO  LABEL_2
			btfss		_CX			; MEASURING CAPACITANCE? GOTO  CALIBRATE 
			goto		Label_2		; the Mode of LC-meter
			btfsc		Temp, 07	; the Delay between modes
			goto		Calibration
			incf		Temp, F
			movlw		0xFF
			call		Delay
			goto		Meter
Label_2		call		CursorHome
			movlw		0x77
			movwf		Temp
			btfsc		Flags, 1	; the Input in a mode of double calibration
			goto		DoubleCheck	; switch F1/F2 has been switched
			call		Measure		; A=F2^2
			btfsc		_LX		; If in the middle of mode Cx,
			goto		Label_6		; that simple transition
			btfss		Flags, 5	; If we leave a mode
			goto		Label_7		; double calibration,
			btfsc		Flags, 6	; that is necessary 
			call		ClrDSP		; to clear the display
			bcf			Flags, 6	; and to dump a flag
Label_7		btfsc		Flags, 6	; If the flag is established
			goto		CalcDouble	; the mode of double calibration Proceeds
Label_6		btfsc		Flags, 6	; If from dv. Calibre. At once went 
			call		ClrDSP		; to measurement of capacity it is necessary once
			bcf			Flags, 6	; to clear the display and to dump a flag

;	A general part of calculation for capacity and inductance
			call		BEQUA		; B=F2^2
			movlw		FDX		; Frequency of the generator with
			call		Copy_To_A	; a contour only from L1 and C1
			call		Div		; A=F1^2/F2^2
			call		ClrB		; Loading in In units
			movlw		0x81		; (a kind with a floating point)
			movwf		BX		; B=1
			call		Sub		; A=F1^2/F2^2-1
			movf		AX, W
			btfss		STATUS, Z	; If result positive,,
			goto		NoNeg		; that further
			call		ClrA		; otherwise to null And
NoNeg		btfsc		_LX		; the Branching of calculation
			goto		Cx_Meas		; for capacity or inductance
			movlw		LX		; Extraction of inductance L1
			call		Copy_To_B	; from soostvetstvujushchego bank
			call		Mpy		; A=(F1^2/F2^2-1)*L1
DispLX			bsf	STATUS,RP0
			movlw		0x27
			call		ReadWString
			btfss		Flags, 5
			goto		CheckOK
			call		ClrA
CheckOK		goto		DispVal		; the Conclusion of result
Cx_Meas		movlw		CX		; Doraschyot for capacity
			call		Copy_To_B
			call		Mpy		; A=(F1^2/F2^2-1)*C1
			call  		ClrDSP
			bsf	STATUS,RP0
			movlw		0x20
			call		ReadWString
			bsf	STATUS,RP0
			movlw		0x30
			call		ReadWString

; Indication of result
DispVal		call		TestBat
			clrf		TSign		; TSign = 0
NoOne		movf		AX, W		;  A>=1
			sublw		0x80
			btfsc		STATUS, C	
			goto		IsOne		; <1, =*10^TSign

			call		ClrB
			movlw		0x84		; A=A/10
			movwf		BX
			movlw		0x20
			movwf		B0

			call		Div
			incf		TSign, F	; TSign=TSign+1

			goto		NoOne

IsOne		movlw		0x8E		; A=10000
			movwf		BX		; we Shall result And in an integer
			movlw		0x1C
			movwf		B0
			movlw		0x40
			movwf		B1
			clrf		B2

			call		Mpy		; A=INT(A*10000)
			call		Int		; In a format with fiks. A point
			call		BCD		; In ASCII  a format
			movf		TSign, W	; the Multiplier we shall keep in AX
			movwf		AX		; AX = TSign
			movlw		'u'		; "u"
			movwf		LP		; the Prefix for inductance
			movlw		'p'		; "p"
			movwf		CP		; the Prefix for capacity

AX0			movf		AX, W		; If AX=0
			btfss		STATUS, Z
			goto		AX1   		; otherwise further
			call		Disp0		; the Conclusion 0.12 for capacity
			call		DispDot
			call		Digit1
			call		Digit2

			btfsc		_LX
			goto		SP
			call		Digit3		; or 0.123 for inductance
			goto		Units

AX1			decfsz		AX, F		; If A=1
			goto		AX2   		; otherwise further

AX1Disp		call		Digit1		;the Conclusion 1.23 for capacity
			call		DispDot
			call		Digit2        
			call		Digit3

			btfsc		_LX
			goto		SP
			call		Digit4		; or 1.234 for inductance
			goto		Units

AX2			decfsz		AX, F		; If A=2

			goto		AX3   

AX2Disp		call		Digit1		; the Conclusion 12.34
			call		Digit2
			call		DispDot
			call		Digit3
			call		Digit4
			goto		Units		; AND ENG UNITS

AX3			decfsz		AX, F		; If A=3
			goto		AX4   

AX3Disp		call		Digit1		; the Conclusion 123.4

			call		Digit2
			call		Digit3
			call		DispDot
			call		Digit4
			goto		Units

AX4			movlw		'm'
			movwf		LP		; the Prefix "m" - milli
			movlw		'n'
			movwf		CP		; "n" - nano

			decfsz		AX, F		; If A=4
			goto		AX5

AX4Disp		call		Digit1		; the Conclusion 1.234
			call		DispDot
			call		Digit2
			call		Digit3
			call		Digit4
			goto		Units

AX5			movlw		0xE4        
			decfsz		AX, F		; =5
			goto		AX6
			goto		AX2Disp		; 12.34

AX6			decfsz		AX, F		; A=6
			goto		AX7
			goto		AX3Disp		; 123.4

AX7			movlw		" "
			movwf		LP		; there Is no prefix
			decfsz		AX, F		; =7
			goto		AX2Disp		; 12.34 H
			goto		AX1Disp		; 1.234 H

SP			call		DispSP
Units		btfsc		_LX
			goto		DispCap
			movf		LP, W
			call		CharLCD		; the Conclusion of a prefix u, m or it is empty
			movlw		'H'
			call		CharLCD

			call		DispSP

			btfsc		Flags, 6	; In a mode dv. Calibrations 
			return				; an output here,

			goto		Meter		; and in usual here

DispCap		movf		CP, W		;  the Prefix for capacity
			call		CharLCD

			movlw		'F'
			call		CharLCD
			call		DispSP

			goto		Meter

;	A conclusion of the category and preparation for a conclusion of following
DispBCD		movwf		FSR
NextNibble	swapf		INDF,F
			movf		INDF,W
			call		NumLCD
			return

Digit1		movlw		BCD1		; Category 1
			goto		DispBCD
Digit2		EQU			Digit1		; Category 2

Digit3		movlw		BCD0		; Category 3
			goto		DispBCD
Digit4		EQU			Digit3		; Category 4

;	 Subroutines of pauses
Dly5:		movlw		7		; 5 milliseconds
			goto		Delay
DLY200		movlw		0x3F		; 200 micro seconds
			movwf		T1		; 9+(3T1+2)T2 min step 5
			movlw		1
			goto		Delay2
Delay		clrf		T1
Delay2		movwf		T0
DelayL		decfsz		T1, F
			goto		DelayL
			decfsz		T0, F
			goto		DelayL
			return

;	0,5 seconds
Delay05sec	movlw		0x02
DelayXsec	movwf		T2
TD1			movlw		0xFF
			call		Delay
			decfsz		T2, F
			goto		TD1
			return

;	 Translation of the index  into the second symbol of the second line
SecLine		movlw		0xC1


;	 Loading a command
CmdLCD		movwf		Temp4
			bcf			_RS
			goto		SendLCD
;	Code conversion in ASCII and a conclusion
NumLCD		andlw		0x0F		; a mask
			iorlw		0x30		; ASCII
;	Conclusion ASCII of a symbol
CharLCD		movwf		Temp4
			bsf			_RS
SendLCD		swapf		Temp4, W
			andlw		0x0F
			movwf		PORTB
			bsf			_E
			bcf			_E
			movf		Temp4, W
			andlw		0x0F
			movwf		PORTB
Send		bsf			_E
			bcf			_E
			clrf		PORTB
			call		DLY200
			return

CursorHome	movlw		0x02		; the Display in an initial condition
			goto		LongSend
ClrDSP		movlw		1		; Clearing of the display
LongSend	call		CmdLCD
			goto		Dly5

DispDot		movlw		"."
			goto		CharLCD

Disp0		movlw		"0"
			goto		CharLCD

DispSP		movlw		" "
			goto		CharLCD


;	Measurement of frequency from input RA4 with the period of measurement in 0,2 and 1 second
Measure		clrf		TimerH
			clrf		TimerHH
			clrf		INTCON
			clrf		TMR0



			movlw		.41		; the Pause for 0,2 sek
			btfss		_FX
	        movlw	  	.206		; the Pause for 1 sek
	        movwf		Count2        

			bsf			STATUS, RP0	; the Beginning of measurement
			movlw		b'00010010'
			movwf		TRISA
			bcf			STATUS, RP0

Pause2		movlw		.22
			movwf		Count1
Pause1		call		Provtmr		; Check of the counter on overflow
			call		DLY200
			decfsz		Count1, F
	        goto		Pause1
			nop
			decfsz		Count2, F
			goto		Pause2

			movlw		.60		; 0.2 sec
			btfss		_FX
			movlw		.170		; 1 sec
			movwf		Count1

Pause3		call		Provtmr		; Check of the counter on overflow
			goto		$+1
			call		Provtmr
			decfsz		Count1, F
			goto		Pause3

			bsf			STATUS, RP0
			movlw		b'00000010'	; a RA4-input
			movwf		TRISA        
			bcf			STATUS, RP0

			call		Provtmr		; Last check of the counter on overflow

;	The analysis of contents of a preliminary divider
			movf		TMR0, W		; Transfer of given
			movwf		TimerM		; the counter in TimerM
			clrf		TimerL

Cont		bsf			STATUS, RP0
			bsf			OPTION_REG, T0SE	; Doschyot	
			nop
			bcf			OPTION_REG, T0SE
			bcf			STATUS, RP0
			decf		TimerL, F
			movf		TMR0, W
			xorwf		TimerM, W
			btfsc		STATUS, Z
			goto		Cont

			movlw		TimerHH		; Copying measured
			call		Copy_To_A	; values in the block And

			bcf			Flags, 5	; Installation of a flag
			movlw		0xF0		; if the measured value
			andwf		TimerL, W	; less than 80 Hz, i.e. inductance
			iorwf		TimerM, W	; it is not connected
			iorwf		TimerH,	W
			btfsc		STATUS,	Z
			bsf			Flags, 5

			btfss		_FX		; the Output here in 
			return				; a mode chastotometra

			call		Float		; the Floating point
			call		BEQUA		; B=A
			call		Mpy		; A=A*A squaring
			return

;	Check TMR0 on overflow
Provtmr		btfss		INTCON, T0IF	; Check of overflow
	        goto		Paus		; no, we go on a pause.
			movlw		0xFF		; whether Check it is equal
			bcf			STATUS, Z	; TimerH=0xFF
			subwf		TimerH, W
			btfss		STATUS, Z
	       	goto		No
			incf		TimerHH, F	; if it is equal, it is increased
			clrf		TimerH		; TimerHH on unit and
			bcf			INTCON, T0IF	; we null TimerH
			goto		Ret
No			incf		TimerH, F
			bcf			INTCON, T0IF
			nop
			goto		Ret
Paus		nop
			goto		$+1		; alignment of duration Is simple
			goto		$+1		; performance of the subroutine 
			goto		$+1		; for various variants
			goto		$+1		; a course of events
Ret			return


;	Code conversion of value from binary in a decimal format
BCD			movlw		0x20
			movwf		T1
			clrf		BCD0
			clrf		BCD1
			clrf		BCD2
			clrf		BCD3
			clrf		BCD4

BcdLoop		rlf			A2, F
			rlf			A1, F
			rlf			A0, F
			rlf			AX, F

			rlf			BCD0, F
			rlf			BCD1, F
			rlf			BCD2, F
			rlf			BCD3, F
			rlf			BCD4, F
			decfsz		T1, F
			goto		Adjust
			return

Adjust		movlw		.5
			movwf		Count2 ; , F ;count2

			movlw		BCD0
			movwf		FSR
			goto		ADloop+1

ADloop		incf		FSR, F
			call		Adjbcd
			decfsz		Count2, F
			goto		ADloop
			goto		BcdLoop

Adjbcd		movlw		0x03
			addwf		INDF, W
			movwf		T0		
			btfsc		T0, 3		
			movwf		INDF
			movlw		0x30
			addwf		INDF, W
			movwf		T0
			btfsc		T0, 7
			movwf		INDF
			return

;	32 bit bibliteka with a floating point
EXPBIAS		equ	H'80'		; Base of representation of number

;	Converting 24 bit numbers from the block And in a format from a square a point 32 bat in the block 
Float		movlw		0x18+EXPBIAS
			movwf		AX
			clrf		Sign

;	Normalization
NRM32		clrf		T0
			movf		A0, W
			BTFSS		STATUS, Z
			goto		NORM32
			movf		A1, W
			movwf		A0
			movf		A2, W
			movwf		A1
			clrf		A2
			bsf			T0, 3

			movf		A0, W
			btfss		STATUS, Z
			goto		NORM32
			movf		A1, W
			movwf		A0
			clrf		A1
			bcf			T0, 3
			bsf			T0, 4
	
			movf		A0, W
			btfsc		STATUS, Z
			goto		RES032

NORM32		movf		T0, W
			subwf		AX, F
			bcf			STATUS, C

NORM32A		btfsc		A0, MSB
			goto		FIXSIGN32
			rlf			A2, F
			rlf			A1, F
			rlf			A0, F
			decf		AX, F
			goto		NORM32A


FIXSIGN32	btfss		Sign, MSB
			bcf			A0, MSB
			retlw		0

;	result:	A  <--  INT( A )
Int			bsf			A0, MSB

			movlw		EXPBIAS
			subwf		AX, F
			btfss		AX, MSB
			btfsc		STATUS, Z
			goto		RES032
			movf		AX, W
			sublw		0x18
			movwf		AX

SHIFT32		bcf			STATUS, C
			rrf			A0, F
			rrf			A1, F
			rrf			A2, F
			decfsz  	AX, F
			goto		SHIFT32
			retlw		0
                
RES032		call		ClrA
						; clear AX for other routines
INT32OK		retlw		0


;	 Result: A  <- A * B
Mpy			movf		AX, W
			btfss		STATUS, Z
			movf		BX, W
			btfsc		STATUS, Z
			goto		RES032

M32BNE0		movf		A0, W
			xorwf		B0, W
			movwf		Sign

			movf		BX, W
			addwf		AX, F
			movlw		EXPBIAS
			btfss		STATUS, C
			goto		MTUN32
			addwf		AX, F
			goto		MOK32
MTUN32		addwf		AX, F
MOK32		bsf			A0, MSB
			bsf			B0, MSB
			bcf			STATUS, C
			clrf		A3
			clrf		A4
			clrf		A5
			movlw		0x18
			movwf		T0

MLOOP32		btfss		A2, LSB
			goto		MNOADD32

MADD32		movf		B2, W
			addwf		A5, F
			movf		B1, W
			btfsc		STATUS, C
			incfsz		B1, W
			addwf		A4, F

			movf		B0, W
			btfsc		STATUS, C
			incfsz		B0, W
			addwf		A3, F

MNOADD32	rrf			A3, F
			rrf			A4, F
			rrf			A5, F
			rrf			A0, F
			rrf			A1, F
			rrf			A2, F
			bcf			STATUS, C
			decfsz		T0, F
			goto		MLOOP32

			btfsc		A3, MSB
			goto		MUL32OK
			rlf			A0, F
			rlf			A5, F
			rlf			A4, F
			rlf			A3, F
			decf		AX, F

MUL32OK		btfss		Sign, MSB
			bcf			A3, MSB

			movf		A3, W
			movwf		A0
			movf		A4, W
			movwf		A1
			movf		A5, W
			movwf		A2
			retlw		0  


;	result:	A  <--  A / B
Div			movf		A0, W
			xorwf		B0, W
			movwf		Sign
			bsf			A0, MSB
			bsf			B0, MSB

TALIGN32	clrf		T0
			movf		A0, W
			movwf		A3
			movf		A1, W
			movwf		A4
			movf		A2, W
			movwf		A5

			movf		B2, W
			subwf		A5, F
			movf		B1, W
			btfss		STATUS, C
			incfsz		B1, W

TS1ALIGN32	subwf		A4, F
			movf		B0, W
			btfss		STATUS, C
			incfsz		B0, W

TS2ALIGN32	subwf		A3, F

			clrf		A3
			clrf		A4
			clrf		A5

			btfss		STATUS, C
			goto		DALIGN32OK

			bcf			STATUS, C
			rrf			A0, F
			rrf			A1, F
			rrf			A2, F
			rrf			A3, F
			movlw		0x01
			movwf		T0

DALIGN32OK	movf		BX, W
			subwf		AX, F
			btfss		STATUS, C
			goto		ALTB32
	
AGEB32		movlw		EXPBIAS
			addwf		T0, W
			addwf		AX, F
			goto		DARGOK32

ALTB32		movlw		EXPBIAS
			addwf		T0, W
			addwf		AX, F

DARGOK32	movlw		.24
			movwf		T1

DLOOP32		rlf			A5, F
			rlf			A4, F
			rlf			A3, F
			rlf			A2, F
			rlf			A1, F
			rlf			A0, F
			rlf			T0, F

			movf		B2, W
			subwf		A2, F
			movf		B1, W
			btfss		STATUS, C
			incfsz		B1, W
DS132		subwf		A1, F

			movf		B0, W
			btfss		STATUS, C
			incfsz		B0, W
DS232		subwf		A0, F

			rlf			B0, W
			iorwf		T0, F
		
			btfss		T0, LSB
			goto		DREST32

			bsf			A5, LSB
			goto		DOK32

DREST32		movf		B2, W
			addwf		A2, F
			movf		B1, W
			btfsc		STATUS, C
			incfsz		B1, W
DAREST32	addwf		A1, F

			movf		B0, W
			btfsc		STATUS, C
			incf		B0, W
			addwf		A0, F

			bcf			A5, LSB

DOK32		decfsz		T1, F
			goto		DLOOP32

DDIV32OK	btfss		Sign, MSB
			bcf			A3, MSB

			movf		A3, W
			movwf		A0
			movf		A4, W
			movwf		A1
			movf		A5, W
			movwf		A2

			retlw		0


;	result:	A  <--  A - B
Sub			movf		BX, W
			btfss		STATUS, Z
			goto		SUB1
			movf		B0, W
			btfsc		STATUS, Z
			retlw		0
SUB1		movlw		0x80
			xorwf		B0, F


;	Result:	A  <--  A - B
Add			movf		A0, W
			xorwf		B0, W
			movwf		T0

			movf		AX, W
			subwf		BX, W
			btfss		STATUS, C
			goto		USEA32
	
			call		ASwapB

USEA32		movf		A0, W
			movwf		Sign
			bsf			A0, MSB
			bsf			B0, MSB

			movf		B0, W
			movwf		A3
			movf		B1, W
			movwf		A4
			movf		B2, W
			movwf		A5

			movf		BX, W
			subwf		AX, W
			movwf		BX
			btfsc		STATUS, Z
			goto		ALIGNED32

			movlw		8
			subwf		BX, W
			btfss		STATUS, C
			goto		ALIGNB32
			movwf		BX
			rlf			A5, F
			movf		A4, W
			movwf		A5
			movf		A3, W
			movwf		A4
			clrf		A3

			movlw		8
			subwf		BX, W
			btfss		STATUS, C
			goto		ALIGNB32
			movwf		BX
			rlf			A5, F
			movf		A4, W
			movwf		A5
			clrf		A4


ALIGNB32	movf		BX, W
			btfsc		STATUS, Z
			goto		ALIGNED32

ALOOPB32	bcf			STATUS, C
			rrf			A3, F
			rrf			A4, F
			rrf			A5, F
			decfsz		BX, F
			goto		ALOOPB32

ALIGNED32	btfss		T0, MSB
			goto		AOK32

			comf		A3, F
			comf		A4, F
			comf		A5, F
			incf		A5, F
			btfsc		STATUS, Z
			incf		A4, F
			btfsc		STATUS, Z
			incf		A3, F

AOK32		movf		A5, W
			addwf		A2, F
			movf		A4, W
			btfsc		STATUS, C
			incfsz		A4, W
			addwf		A1, F

			movf		A3, W
			btfsc		STATUS, C
			incfsz		A3, W
			addwf		A0, F

			btfsc		T0, MSB
			goto		ACOMP32
			btfss		STATUS, C
			goto		FIXSIGN32

			rrf			A0, F
			rrf			A1, F
			rrf			A2, F
			incf	        AX, F
			goto		FIXSIGN32

ACOMP32		btfsc		STATUS, C
			goto		NRM32

			comf		A0, F
			comf		A1, F
			comf		A2, F
			incf		A2, F
			btfsc		STATUS, Z
			incf		A1, F
			btfsc		STATUS, Z
			incf		A0, F

			movlw		0x80
			xorwf		Sign, F
			goto		NRM32
                END

